{
unit Lang

  ES: unidad para facilitar el cambio de idioma en los errores
  EN: unit to facilitate the change of language of the errors

=========================================================================
History:

ver 0.1.9
  ES:
    nuevo: documentacin
    nuevo: aadido el idioma dans (gracias Hugo Pedersen)
  EN:
    new: documentation
    new: added danish language (thanks Hugo Pedersen)

ver 0.1.7
  ES:
    nuevo: aadido el idioma portugus (gracias Moacir Fortes)
  EN:
    new: added portuguese language (thanks Moacir Fortes)

ver 0.1.6
  ES:
    nuevo: aadido el idioma francs (gracias Stphane)
  EN:
    new: added french language (thanks Stphane)

ver 0.1:
  ES: primera versin
  EN: first version
=========================================================================
IMPORTANTE PROGRAMADORES: Por favor, si tienes comentarios, mejoras,
  ampliaciones, errores y/o cualquier otro tipo de sugerencia, envame un correo a:
  gmlib@cadetill.com

IMPORTANT PROGRAMMERS: please, if you have comments, improvements, enlargements,
  errors and/or any another type of suggestion, please send me a mail to:
  gmlib@cadetill.com
=========================================================================

Copyright () 2011, by Xavier Martinez (cadetill)

@author Xavier Martinez (cadetill)
@web  http://www.cadetill.com
}
{*------------------------------------------------------------------------------
  Lang unit contains strings messages error displayed by the components and a function to do the translation.
  To add a new language you must be to do these steps:
  - create a new constant array with all translations
  - add the new language to set GMConstants.TLang
  - change the GetTranslateText function by adding new language

  @author Xavier Martinez (cadetill)
  @version 0.1.9
-------------------------------------------------------------------------------}
{=------------------------------------------------------------------------------
  La unit Lang contiene las cadenas de los mensajes de error mostrados por los componentes y una funcin para realizar la traduccin.
  Para aadir un nuevo idioma se tendrn que hacer estos pasos:
  - crear una nueva constante de tipo array con todas las traducciones
  - aadir el nuevo idioma al conjunto GMConstants.TLang
  - modificar la funcin GetTranslateText aadiendo el nuevo idioma del conjunto

  @author Xavier Martinez (cadetill)
  @version 0.1.9
-------------------------------------------------------------------------------}
unit Lang;

interface

uses
  GMConstants;

const
  {*------------------------------------------------------------------------------
    Array with messages in Spanish
  -------------------------------------------------------------------------------}
  {=------------------------------------------------------------------------------
    Array con los mensajes en espaol
  -------------------------------------------------------------------------------}
  Lang_ESP: array[0..14] of string = (
      'No se ha especificado el objeto WebBrowser',    // 0
      'Pgina inicial aun no cargada',      // 1
      'El mapa todava no ha sido creado',  // 2
      'No est activo',                     // 3
      'No se ha podido cargar el recurso',  // 4
      'Este objeto no tiene relacin en JavaScript',  // 5
      'Id de JavaScript incorrecto',        // 6
      'Id de JavaScript inexistente',       // 7
      'Nmero de parmetros incorrecto',    // 8
      'Tipo de parmetro incorrecto',       // 9
      'Valor de parmetro incorrecto',      // 10
      'ndice fuera de rango',              // 11
      'Mapa no asignado',                   // 12
      'El fichero no existe',               // 13
      'El nmero de columna es incorrecto'  // 14
      );

  {*------------------------------------------------------------------------------
    Array with messages in English
  -------------------------------------------------------------------------------}
  {=------------------------------------------------------------------------------
    Array con los mensajes en ingls
  -------------------------------------------------------------------------------}
  Lang_ENG: array[0..14] of string = (
      'WebBrowser not defined',             // 0
      'Initial page not loaded',            // 1
      'The map is not yet created',         // 2
      'Not active',                         // 3
      'Can''t load resource',               // 4
      'This object has no relation in JavaScript', // 5
      'Id from JavaScript incorrect',       // 6
      'JavaScript Id does not exist',       // 7
      'Incorrect number of parameters',     // 8
      'Incorrect type parameter',           // 9
      'Incorrect value parameter',          // 10
      'Index out of range',                 // 11
      'Map not assigned',                   // 12
      'File does not exist',                // 13
      'The col number is incorrect'         // 14
      );

  {*------------------------------------------------------------------------------
    Array with messages in French
  -------------------------------------------------------------------------------}
  {=------------------------------------------------------------------------------
    Array con los mensajes en francs
  -------------------------------------------------------------------------------}
  Lang_FRE: array[0..14] of string = (
      'Navigateur Web non dfini',          // 0
      'Page initiale non charge',          // 1
      'La carte n''est pas encore cre',   // 2
      'Non actif',                          // 3
      'Ne peux pas charger la ressource',   // 4
      'Cet object n''a pas de relation dans JavaScript', // 5
      'Id JavaScript incorrect',            // 6
      'Id JavaScript inexistant',           // 7
      'Nombre incorrecte de paramtres',    // 8
      'Type de paramtre incorrect',        // 9
      'Valeur de paramtre incorrecte',     // 10
      'Indice hors limites',                // 11
      'Carte non attribue',                // 12
      'Le fichier n''existe pas',           // 13
      'Le numro de colonne est incorrect'  // 14
      );

  {*------------------------------------------------------------------------------
    Array with messages in Brazilian Portuguese
  -------------------------------------------------------------------------------}
  {=------------------------------------------------------------------------------
    Array con los mensajes en portugus de Brasil
  -------------------------------------------------------------------------------}
  Lang_PTBR: array[0..14] of string = (
      'Navegador Web no definido',                // 0
      'Pgina inicial no foi carregada',          // 1
      'O mapa ainda no foi criado',               // 2
      'Inativo',                                   // 3
      'No  possvel carregar recursos',          // 4
      'Este objeto no tem relao em JavaScript', // 5
      'Id do JavaScript incorreto',                // 6
      'Id do JavaScript no existe',               // 7
      'Nmero incorreto de parmetros',            // 8
      'Tipo de parmetro incorreto',               // 9
      'Valor do parmetro incorreto',              // 10
      'ndice fora do intervalo',                  // 11
      'Mapa no atribudo',                        // 12
      'O arquivo no existe',                      // 13
      'O nmero da coluna est errado'             // 14
      );

  {*------------------------------------------------------------------------------
    Array with messages in Danish
  -------------------------------------------------------------------------------}
  {=------------------------------------------------------------------------------
    Array con los mensajes en dans
  -------------------------------------------------------------------------------}
  Lang_DAN: array[0..14] of string = (
      'WebBrowser ikke defineret',                      // 0
      'Frste side er ikke hentet',                     // 1
      'Kortet er ikke dannet endnu',                    // 2
      'Ikke aktiv',                                     // 3
      'Kan ikke hente ressource',                       // 4
      'Dette object har ingen relation i JavaScript',   // 5
      'Id fra JavaScript er forkert',                   // 6
      'JavaScript Id findes ikke',                      // 7
      'Forkert antal parametre',                        // 8
      'Forkert parameter type',                         // 9
      'Forkert vrdi parameter',                        // 10
      'Index uden for omrde',                          // 11
      'Kort ikke angivet',                              // 12
      'Filen findes ikke',                              // 13
      'Antal kolonner er forkert'                       // 14
      );

  {*------------------------------------------------------------------------------
    GetTranslateText fucntion retrieves a translated string into the Lang language
    @param Text string to translate
    @param Lang destination language
    @return translated string
  -------------------------------------------------------------------------------}
  {=------------------------------------------------------------------------------
    La funcin GetTranslateText devuelve una cadena traducida al idioma Lang
    @param Text cadena a traducir
    @param Lang lenguaje destino
    @return cadena traducida
  -------------------------------------------------------------------------------}
  function GetTranslateText(Text: string; Lang: TLang): string;

implementation

{ TLanguage }

function GetTranslateText(Text: string; Lang: TLang): string;
  function GetIndex(Text: string): Integer;
  var
    i: Integer;
  begin
    Result := 0;
    for i := 1 to High(Lang_ESP) do
      if Text = Lang_ESP[i] then
      begin
        Result := i;
        Break;
      end;
  end;
begin
  case Lang of
    English: Result := Lang_ENG[GetIndex(Text)];
	  French: Result := Lang_FRE[GetIndex(Text)];
    PortuguesBR: Result := Lang_PTBR[GetIndex(Text)];
    Danish: Result := Lang_DAN[GetIndex(Text)];
    else Result := Text;
  end;

  if Result = '' then Result := Text;
end;

end.
